#!/usr/bin/ruby
#
# iCal Filter
# Ver 1.1
#
# iCalνϤicsե֤ǥե륿꺹ʬϤꤹ롣
# iCalνϤicsեPalmDesktop 4.0.1Ŭڤ˰褦˲ù롣
# Ϥϥ󥽡ʤΤŬڤ˥쥯Ȥ뤳ȡ
# ޤϤUTF-8ʤнϤUTF-8ˤʤΤnkfʤɤŬڤʸ󥳡ɤѴ뤳ȡ
#
# Copyright (C) 2008, Takeshi Yoneki / OSTRACISM CO.

$inCalFile1 = nil
$inCalFile2 = nil
$startDate = -1
$endDate = -1
$header = false
$command = "output-normal"
$summary = false
$locationToDesc = false
$outAsIs = true
currentOption = ""

ARGV.each do |arg|
	if arg == "--startdate" or arg == "-sd" then
		currentOption = "--startdate"
	elsif arg == "--enddate" or arg == "-ed" then
		currentOption = "--enddate"
	elsif arg == "--header" or arg == "-h" then
		$header = true
	elsif arg == "--summary" or arg == "-s" then
		$summary = true
	elsif arg == "--location" or arg == "-l" then
		$locationToDesc = true
	elsif arg == "--asis" or arg == "-i" then
		$outAsIs = true
	elsif arg == "--palm" or arg == "-p" then
		$outAsIs = false
		$locationToDesc = true
	elsif arg == "--normal" or arg == "-n" then
		$command = "output-normal"
	elsif arg == "--added" or arg == "-a" then
		$command = "output-added"
	elsif currentOption == "--startdate" then
		$startDate = arg.to_i
		currentOption = ""
	elsif currentOption == "--enddate" then
		$endDate = arg.to_i
		currentOption = ""
	elsif $inCalFile1 == nil then
		$inCalFile1 = arg
	elsif $inCalFile2 == nil then
		$inCalFile2 = arg
	end
end

if $inCalFile1 == nil then
	print "usage : icalfilter [--startdate --enddate --added --summary] iCalFilePath\n"
	exit
end

class VEvent
	attr_accessor :members, :startDate, :startTime, :startLine, :endDate, :endTime, :endLine, :summary, :description, :tagNameOfSummary, :tagNameOfDescription

	def initialize
		@members = Array.new
		@startDate = -1
		@startTime = -1
		@startLine = ""
		@endDate = -1
		@endTime = -1
		@endLine = ""
		@summary = ""
		@description = ""
		@tagNameOfSummary = "SUMMARY:"
		@tagNameOfDescription = "DESCRIPTION:"
	end

	def pickDateTime(s)
		d = Array.new
		m = /:.*/.match(s)
		if m[0] != nil then
			d = m[0].split(/:/)[1].split(/T/)
		end
		d
	end

	def setStartDateTime(s)
		d = pickDateTime(s)
		if d[0] != nil then
			@startDate = d[0].to_i;
		end
		if d[1] != nil then
			@startTime = d[1].to_i
		end
	end

	def setEndDateTime(s)
		d = pickDateTime(s)
		if d[0] != nil then
			@endDate = d[0].to_i;
		end
		if d[1] != nil then
			@endTime = d[1].to_i
		end
	end

	def outputEvent()
		printf("BEGIN:VEVENT\n")
		printf("%s\n", @startLine)
		printf("%s\n", @endLine)
		@members.each do |member|
			printf("%s\n", member)
		end
		if @summary.length > 0 then
			printf("%s%s\n", @tagNameOfSummary, @summary)
		end
		if @description.length > 0 then
			printf("%s%s\n", @tagNameOfDescription, @description)
		end
		printf("END:VEVENT\n")
	end
	
	def getSummaryString()
		timeStr = "-     "
		if @startTime > 0 then
			timeStr = format("%06d", @startTime)
		end
		s = @summary
		s.strip!
		format("%08d %s %s", @startDate, timeStr, s)
	end

	def outputSummary()
		printf(getSummaryString())
		printf("\n")
	end

	def checkEffective()
		bOut = true
		if $startDate > 0 then
			if @startDate > 0 then
				if @startDate >= $startDate then
					bOut = true
				else
					bOut = false
				end
			else
				bOut = false
			end
		else
			bOut = true
		end
		
		if bOut and $endDate > 0 then
			if @startDate > 0 then
				if @startDate <= $endDate then
					bOut = true
				else
					bOut = false
				end
			else
				bOut = false
			end
		end
		bOut
	end
end

class VCalender
	attr_accessor :members, :events
	def initialize
		@members = Array.new
		@events = Array.new
	end

	# icsǡΥ
	def load(filePath)
		current = nil

		data = Array.new

		f = File.open(filePath)
		f.each do |line|
			line.chop!
			if line.length == 0 then
				continue
			end
			# ԶԤ줿Ԥ򸵤᤹
			if line[0].chr == ' ' then
				t = line[1 .. line.length - 1]
				c = data[data.size - 1]
				c += t
				data[data.size - 1] = c
			else
				data << line
			end
		end
		f.close

		data.each do |line|
			if line == "BEGIN:VCALENDAR" then
			elsif line == "END:VCALENDAR" then
			elsif line == "BEGIN:VEVENT" then
				current = VEvent.new
			elsif line == "END:VEVENT" then
				if current != nil then
					@events.push(current)
				end
				current = nil
			else
				if current == nil then
					@members.push(line)
				else
					if line =~ /^DTSTART/ then
						current.setStartDateTime(line)
					end
					if line =~ /^DTEND/ then
						current.setEndDateTime(line)
					end
					##
					if $outAsIs then
						if line =~ /^DTSTART/ then
							current.startLine = line
						elsif line =~ /^DTEND/ then
							current.endLine = line
						elsif line =~ /^SUMMARY/ then
							current.summary = getLineBody(line)
						elsif line =~ /^DESCRIPTION/ then
							current.description = getLineBody(line)
						else
							current.members.push(line)
						end			
					else
						if line =~ /^DTSTART/ then
							current.startLine = "DTSTART:" + getLineBody(line)
						elsif line =~ /^DTEND/ then
							current.endLine = "DTEND:" + getLineBody(line)
						elsif line =~ /^SUMMARY/ then
							body = simpleEscapeDecode(getLineBody(line))
							mime = simpleMIMEEncode(body)
							if body != mime then
								current.tagNameOfSummary = "SUMMARY;QUOTED-PRINTABLE:"
							end
							current.summary = mime
						elsif line =~ /^DESCRIPTION/ or ($locationToDesc and line =~ /^LOCATION/) then
							body = simpleEscapeDecode(getLineBody(line))
							mime = simpleMIMEEncode(body)
							bChangeTag = false
							if current.description.length > 0 then
								current.description += '=0D=0A'
								bChangeTag = true
							else
								if body != mime then
									bChangeTag = true
								end
							end
							if bChangeTag then
								current.tagNameOfDescription = "DESCRIPTION;QUOTED-PRINTABLE:"
							end
							current.description += mime
						else
							current.members.push(line)
						end
					end
				end
			end

		end
	end

	# ':'θ
	def getLineBody(line)
		r = ""
		count = line.length
		i = 0
		while i < count do
			if line[i].chr == ':' then
				r = line[i + 1 .. count - 1]
				break
			end
			i += 1
		end
		r
	end

	def outputHeader()
		members.each do |member|
			printf("%s\n", member)
		end
	end
end

# ǤʥХåå奨פβ
def simpleEscapeDecode(s)
	r = ""
	i = 0
	while i < s.length do
		c1 = s[i]
		if c1.chr == "\\" then
			c2 = s[i + 1]
			if c2.chr == "n" or c2.chr == "N" then
				r += "\r\n"
			elsif c2.chr == "\\" then
				r += "\\"
			elsif c2.chr == ";" then
				r += ";"
			elsif c2.chr == "," then
				r += ","
			else
				r += "\\"
				i -= 1
			end
			i += 1
		else
			r += c1.chr
		end
		i += 1
	end
	r
end

# ǤMIME󥳡ɡ
# QUOTED-PRINTABLEΤߤǤȤꤢԤޤ֤Ϥʤ
def simpleMIMEEncode(s)
	r = ""
	i = 0
	while i < s.length do
		c = s[i]
		if c < 0x20 or c == 0x7F or c.chr == "=" then
			r += sprintf("=%02X", c)
		else
			r += c.chr
		end
		i += 1
	end
	r
end

def calcUnixTime(s)
	m = /:.*/.match(s)
	if m[0] != nil then
		#p m[0]
		d = m[0].split(/:/)[1].split(/T/)
		if d[0] != nil then
			d[0].to_i;
		end
		if d[1] != nil then
			p d[1]
		end
	end
	0
end

def outputNormal(vCal)
	if $summary == false then
		printf("BEGIN:VCALENDAR\n")
	end

	if $header && $summary == false then
		vCal.outputHeader()
	end

	vCal.events.each do |event|
		if 	event.checkEffective() then
			if $summary then
				event.outputSummary()
			else
				event.outputEvent()
			end
		end
	end

	if $summary == false then
		printf("END:VCALENDAR\n")
	end
end

def	extractAddedVCal()
	vCalResult = VCalender.new
	vCal1 = VCalender.new
	vCal1.load($inCalFile1)
	vCal2 = VCalender.new
	vCal2.load($inCalFile2)

	oneHash = Hash.new(nil)
	vCal1.events.each do |event|
		oneHash[event.getSummaryString()] = event
	end

	vCal2.events.each do |event|
		if oneHash[event.getSummaryString()] == nil then
			vCalResult.events.push(event)
		end
	end
	vCalResult
end

if $command == "output-added" then
	outputNormal(extractAddedVCal())
else
	vCal = VCalender.new
	vCal.load($inCalFile1)
	outputNormal(vCal)
end

exit
