//
// PalmDateBookUtil
// PalmDateBookUtil.cpp
// Palm Desptop 4.0.1 datebook.dat ΏۂƂ[eBeB
// 1. T}[̕\
// 2. vcso
// 3. d̏
//

#include "TDateBook.h"
#include <stdio.h>
#include <map>

#pragma warning(disable : 4996)

class PDBUtil {
public:
	PDBUtil();
	enum function {
		FUNC_DUMPSUMMARY,
		FUNC_DUMPVCS,
		FUNC_DROPREDUNDANCY
	};
	function m_function;
	std::string m_path1;
	std::string m_path2;
	bool m_bUTC;
	PalmDateBook::TDateBookEntry::VEVENT_ENCODE m_encode;
	void option(int argc, char* argv[]);
	bool DumpSummary(std::string srcPath);
	bool DumpVCS(std::string srcPath);
	bool DropRedundancy(std::string srcPath, std::string dstPath);
};

int main(int argc, char* argv[])
{
	PDBUtil util;

	util.option(argc, argv);

	if (util.m_function == PDBUtil::FUNC_DROPREDUNDANCY) {
		util.DropRedundancy(util.m_path1.c_str(), util.m_path2.c_str());
	}
	else if (util.m_function == PDBUtil::FUNC_DUMPVCS) {
		util.DumpVCS(util.m_path1.c_str());
	}
	else {
		util.DumpSummary(util.m_path1.c_str());
	}

	return 0;
}

PDBUtil::PDBUtil() {
	m_function = FUNC_DUMPSUMMARY;
	m_bUTC = false;
	m_encode = PalmDateBook::TDateBookEntry::VEVENT_ENCODE_MIME_QP;
}

void PDBUtil::option(int argc, char* argv[]) {
	for (int i = 1; i < argc; i++) {
		std::string param = argv[i];
		if (param == "-r" || param == "--redundancy") {
			m_function = FUNC_DROPREDUNDANCY;
		}
		else if (param == "-s" || param == "--summary") {
			m_function = FUNC_DUMPSUMMARY;
		}
		else if (param == "-v" || param == "--vcs") {
			m_function = FUNC_DUMPVCS;
		}
		else if (param == "-u" || param == "--utc") {
			m_function = FUNC_DUMPVCS;
			m_bUTC = true;
		}
		else if (param == "-m" || param == "--mimequotedprintable") {
			m_encode = PalmDateBook::TDateBookEntry::VEVENT_ENCODE_MIME_QP;
		}
		else if (param == "-b" || param == "--backslashescape") {
			m_encode = PalmDateBook::TDateBookEntry::VEVENT_ENCODE_BACKSLASH_ESCAPE;
		}
		else if (m_path1.length() == 0) {
			m_path1 = param;
		}
		else if (m_path2.length() == 0) {
			m_path2 = param;
		}
	}
	if (m_path1.length() == 0)
		m_path1 = "datebook.dat";
	if (m_path2.length() == 0)
		m_path2 = "datebook.new";
}

bool PDBUtil::DumpSummary(std::string srcPath) {
	PalmDateBook::TDateBook db;
	if (!db.Load(srcPath)) {
		std::cerr << "DateBook Error\n";
		return false;
	}

	for (int i = 0; i < db.GetDateBookEntryCount(); i++) {
		char buff[32];
		sprintf(buff, "%d ", db.GetNthDateBookEntry(i)->m_recordID.m_data);
		std::cout << buff;
		std::cout << db.GetNthDateBookEntry(i)->GetSummary(m_encode);
		std::cout << "\n";
	}
	return true;
}

bool PDBUtil::DumpVCS(std::string srcPath) {
	PalmDateBook::TDateBook db;
	if (!db.Load(srcPath)) {
		std::cerr << "DateBook Error\n";
		return false;
	}

	std::cout << "BEGIN:VCALENDAR\n";
	std::cout << "VERSION:1.0\n";
	std::cout << "PRODID:PalmDateBookUtil 1.0\n";
	for (int i = 0; i < db.GetDateBookEntryCount(); i++) {
		PalmDateBook::TDateBookEntry *entry = db.GetNthDateBookEntry(i);
		std::vector<std::string> lines;
		if (entry->GetVEVENT(&lines, m_bUTC, m_encode)) {
			for (int i = 0; i < (int)lines.size(); i++) {
				std::cout << lines[i];
				std::cout << "\n";
			}
		}
	}
	std::cout << "END:VCALENDAR\n";
	return true;
}

bool PDBUtil::DropRedundancy(std::string srcPath, std::string dstPath) {
	if (srcPath == dstPath) {
		std::cerr << "Same path Error\n";
		return false;
	}

	PalmDateBook::TDateBook db;
	if (!db.Load(srcPath)) {
		std::cerr << "DateBook Load Error\n";
		return false;
	}

	// datebook.datɓĂGgPalm Desktop 4.0.1œǂ߂ȂȂ̂ŁA
	// L[Ƀ\[gĂ͂ȂB
	// Ăł͏d폜̂
	// 1. SGǧ݂̏ԂɔԍU
	// 2. StO
	// 3. [}bvɓȂtO𗧂Ăd𒲂ׂ
	// 4. dق̃tO
	// 5. SGgȂ߂ătO̗Ă̂VKɔzɓ
	// 6. ozۑB
	// ƂB

	std::vector<bool> enableFlags;
	for (int i = 0; i < db.GetDateBookEntryCount(); i++) {
		PalmDateBook::TDateBookEntry *dbe = db.GetNthDateBookEntry(i);
		dbe->m_refCon = (void *)i;
		enableFlags.push_back(false);
	}
	std::vector<PalmDateBook::TDateBookEntry> dbeArray;
	std::map<std::string, PalmDateBook::TDateBookEntry *> dbeMap;
	std::map<std::string, PalmDateBook::TDateBookEntry *>::iterator pos;
	for (int i = 0; i < db.GetDateBookEntryCount(); i++) {
		PalmDateBook::TDateBookEntry *dbe = db.GetNthDateBookEntry(i);
		std::string key = dbe->GetSummary(m_encode);
		pos = dbeMap.find(key);
		if (pos == dbeMap.end()) {
			dbeMap[key] = dbe;
			std::cout << "-";
			enableFlags[i] = true;
		}
		else {
			if (dbe->m_note.BiggerThan(pos->second->m_note)) {
				enableFlags[i] = true;
				enableFlags[(int)pos->second->m_refCon] = false;
				std::cout << "+";
			}
			else {
				std::cout << "*";
			}
		}
	}

	for (int i = 0; i < db.GetDateBookEntryCount(); i++) {
		PalmDateBook::TDateBookEntry *dbe = db.GetNthDateBookEntry(i);
		if (enableFlags[i])
			dbeArray.push_back(*dbe);
	}

	std::cout << "\n";
	db.m_dateBookEntry = dbeArray;
	if (!db.Save(dstPath)) {
		std::cerr << "DateBook Save Error\n";
		return false;
	}
	return true;
}
